package com.namasoft.specialserialization;

import com.namasoft.common.utilities.ObjectCreator;

public class ObjectCreatorUtil
{
	public static <T> ObjectCreator<T> creator(final String klass)
	{
		try
		{
			return (ObjectCreator<T>) creator(Class.forName(klass));
		}
		catch (ClassNotFoundException e)
		{
			throw new RuntimeException(e);
		}
	}
	public static <T> ObjectCreator<T> creator(final Class<T> klass)
	{
		return () ->
		{
			try
			{
				return klass.newInstance();
			}
			catch (IllegalAccessException | InstantiationException e)
			{
				throw new RuntimeException(e);
			}
		};
	}
}
